package org.apache.cayenne.testdo.lazy.auto;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;

import org.apache.cayenne.BaseDataObject;
import org.apache.cayenne.Fault;
import org.apache.cayenne.exp.property.BaseProperty;
import org.apache.cayenne.exp.property.PropertyFactory;
import org.apache.cayenne.exp.property.StringProperty;

/**
 * Class _Lazyblob was generated by Cayenne.
 * It is probably a good idea to avoid changing this class manually,
 * since it may be overwritten next time code is regenerated.
 * If you need to make any customizations, please use subclass.
 */
public abstract class _Lazyblob extends BaseDataObject {

    private static final long serialVersionUID = 1L; 

    public static final String ID_PK_COLUMN = "ID";

    public static final BaseProperty<byte[]> LAZY_DATA = PropertyFactory.createBase("lazyData", byte[].class);
    public static final StringProperty<String> NAME = PropertyFactory.createString("name", String.class);

    protected Object lazyData;
    protected String name;


    public void setLazyData(byte[] lazyData) {
        beforePropertyWrite("lazyData", this.lazyData, lazyData);
        this.lazyData = lazyData;
    }

    public byte[] getLazyData() {
        beforePropertyRead("lazyData");
        if(this.lazyData instanceof Fault) {
            this.lazyData = ((Fault) this.lazyData).resolveFault(this, "lazyData");
        }
        return (byte[])this.lazyData;
    }

    public void setName(String name) {
        beforePropertyWrite("name", this.name, name);
        this.name = name;
    }

    public String getName() {
        beforePropertyRead("name");
        return this.name;
    }

    @Override
    public Object readPropertyDirectly(String propName) {
        if(propName == null) {
            throw new IllegalArgumentException();
        }

        switch(propName) {
            case "lazyData":
                return this.lazyData;
            case "name":
                return this.name;
            default:
                return super.readPropertyDirectly(propName);
        }
    }

    @Override
    public void writePropertyDirectly(String propName, Object val) {
        if(propName == null) {
            throw new IllegalArgumentException();
        }

        switch (propName) {
            case "lazyData":
                this.lazyData = val;
                break;
            case "name":
                this.name = (String)val;
                break;
            default:
                super.writePropertyDirectly(propName, val);
        }
    }

    private void writeObject(ObjectOutputStream out) throws IOException {
        writeSerialized(out);
    }

    private void readObject(ObjectInputStream in) throws IOException, ClassNotFoundException {
        readSerialized(in);
    }

    @Override
    protected void writeState(ObjectOutputStream out) throws IOException {
        super.writeState(out);
        out.writeObject(this.lazyData);
        out.writeObject(this.name);
    }

    @Override
    protected void readState(ObjectInputStream in) throws IOException, ClassNotFoundException {
        super.readState(in);
        this.lazyData = in.readObject();
        this.name = (String)in.readObject();
    }

}
